 
/*********************************************************************************
*
*			   .  .
*                  				V1.1. 12.2013.
*
**********************************************************************************
*
*	    ,    
*   LC ,      
*   .      -
*      .     -
*   ,    -     . 
* 	        -
*  ,   .     
*     ,  
*   :  1    80 ,  .
*	        PIC-
* ,   AN592 "Frequency Counter Using PIC16C5X" (1997 .).  -
*      T0CKI TMR0,     .
*    ,  0,1 ,   TMR1.   , -
*     TMR1.     -
*   TMR0.         -
*        T0CKI    RB0 PORTB  -
*        (255).
* 	       , -
*   ,      .  
*	          
*  : H=(L*(C-o))/(h-o), : L -   ,
*  -  ,  -   , h -    -
*   .     ,  
* ,    ,     -
*   ,    ,    
*    ,   ,   -
*   ,    .    
* ,      [].
*	     3-  :   [], 
*   []     []. 
*	   .   ""   
*  ,        	  
*   ,    .   
*     ("")      ("h").
*   EEPROM     "<"  ">".  
*      .
*
**********************************************************************************
*
*			 PIC16f628A, Fosc = 20,000 .
*
*********************************************************************************/
#include <htc.h> 
#include <pic.h>
#include <math.h>

__CONFIG(UNPROTECT & LVPDIS & BOREN & MCLREN & PWRTEN & WDTDIS & HS);	// 

#define BITNUM(adr,bit)((unsigned)(&adr)*8+(bit))	// -.
#define NUM_OF_BITS 4								//  .
#define kc 21474836									//K-   .
// E -    .

static bit ON		@ BITNUM(PORTA,0);				//.  "".
static bit TEN		@ BITNUM(PORTA,1);				// -    ---    "".
static bit HUND		@ BITNUM(PORTA,2);				// -    ---    "".
static bit THOUS	@ BITNUM(PORTA,3);				// -    ---    "".
static bit SW_UP	@ BITNUM(PORTB,7);				// "+".
static bit SW_DWN	@ BITNUM(PORTB,6);				// ---   "-".
static bit SW_M		@ BITNUM(PORTB,1);				// ---   "".
static bit F_INP	@ BITNUM(PORTA,4);				// .
static bit F_OUT	@ BITNUM(PORTB,0);				// . 
static bit F_MODE	@ BITNUM(TRISB,0);				//  . 

//PORTB 1 - 7       -  .

unsigned int RCNT=0;								//  .	
unsigned char CNT_SW=0;								//  .
unsigned char SW_M_CNT=0;							//    "".			
unsigned int PARAMETR=0;							//     .
unsigned char MODE=0;								//  .
unsigned char COUNT=0;								// .
unsigned char F_HI=0;								//   .
unsigned int h=0;									//Cmax.     .
unsigned int o=0;									//Cmin.     .
unsigned int L=0;									//  .
unsigned int c=0;									// - .
unsigned long _k=0;									// - .
unsigned int e=0;									// - E.
unsigned long F=0;									//.
unsigned long C=0;									//.
unsigned long H=0;									// .
unsigned long E=0;									//  .
unsigned int _F=0;									//     0.

bit St;												//    .
bit MeasEnd;										//    .
bit ON_T;											//  
bit TEN_T;											// 
bit HUND_T;											//
bit THOUS_T;										//.
		
/*********************************************************************************
*
*			
*
*********************************************************************************/

void Led7x4Dysplay(void)
{
	unsigned char ONES;			// - ,
	unsigned char TENS;			//  ---     - ,
	unsigned char HUNDREDS;		//  ---     - ,
	unsigned char THOUSAND;		//  ---     - ,
	unsigned char BCD;			//- .
	unsigned char CNT;			//  .
	unsigned char SEGM;		    // .

		switch(MODE)				//    :
		{
			case 0:PARAMETR=H;				// ,[],
			break;
			case 2:PARAMETR=C/100;			//,[],
			break;
			case 4:PARAMETR=F/100;			//,[],
			break;
			case 6:PARAMETR=E;				//E,[/],
			break;
			case 8:PARAMETR=h/100;			//Cmax.     ,
			break;
			case 10:PARAMETR=o/100;			//Cmin.     ,
			break;
			case 12:PARAMETR=L;				//  ,	
			break;
			case 14:PARAMETR=c;				// - .
			break;
			case 16:PARAMETR=e;				// - E.			
		}
		ONES=PARAMETR%10;				//-
		TENS=(PARAMETR%100)/10;			// .
		HUNDREDS=(PARAMETR%1000)/100;	// 
		THOUSAND=MODE+10;				// .

		if(CNT>=NUM_OF_BITS)CNT=0;		//   4.
		switch(CNT)						//:
		{
			case 0:BCD=ONES;ON=0;TEN=HUND=THOUS=1;		//0 - ,
			break;
			case 1:BCD=TENS;TEN=0;ON=HUND=THOUS=1;		//1 - ,
			break;
			case 2:BCD=HUNDREDS;HUND=0;ON=TEN=THOUS=1;	//2 - ,
			break;
			case 3:BCD=THOUSAND;THOUS=0;ON=TEN=HUND=1;  //3 - .
		}
		CNT++;							// .
		switch(BCD)						//     
		{   							//  :	
					//    gdefcab 
			case 0:SEGM=0b10000000;			// 0,
			break;
			case 1:SEGM=0b11110100;			// 1,
			break;
			case 2:SEGM=0b00011000;			// 2,
			break;      
			case 3:SEGM=0b00110000;			// 3,
			break;
			case 4:SEGM=0b01100100;			// 4,
			break;
			case 5:SEGM=0b00100010;			// 5,
			break;
			case 6:SEGM=0b00000010;			// 6,
			break;
			case 7:SEGM=0b11110000;			// 7,
			break;
			case 8:SEGM=0b00000000;			// 8,
			break;
			case 9:SEGM=0b00100000;			// 9,
			break;
			case 10:SEGM=0b01000100;		// "H",
			break;
			case 12:SEGM=0b10001010;		// "C",
			break;      
			case 14:SEGM=0b01001010;		// "F",
			break;
			case 16:SEGM=0b00001010;		// "E",
			break;
			case 18:SEGM=0b01000110;		// "h",
			break;
			case 20:SEGM=0b00010110;		// "o",
			break;
			case 22:SEGM=0b10001111;		// "L",
			break;
			case 24:SEGM=0b00011110;		// "c".
			break;
			case 26:SEGM=0b00001000;		// "e".
		}
		PORTB=SEGM;						//   .
}

/*********************************************************************************
*
*			 .
*
*********************************************************************************/
	
void SetMode(void)
{
	unsigned char PARAMETR_H;			//    .  .
	unsigned char PARAMETR_L;			//    .  .
	unsigned char PORTB_T;				//  PORTB.
	
		CNT_SW++;							//    .
		if(CNT_SW>=2)						//  ( 300 ).
		{
			CNT_SW=0;							// .			
			ON_T=ON;TEN_T=TEN;HUND_T=HUND;		// 
			THOUS_T=THOUS;PORTB_T=PORTB;		//.
			ON=TEN=HUND=THOUS=1;				// .
			PORTB=0b11111110;					// ---      .
			TRISB=0b11000011;					//  .
			RCNT=75;							//  
			while(RCNT--!=0);					// .
	  		if(SW_M) SW_M_CNT++;                // "" -   .
      		else                              	//  - 
      		{
        		if(SW_M_CNT)                           	//   - 
        		{
         		 	MODE=MODE+2;                        //  .
          			if(SW_M_CNT<5)                   	//    - 
          			{
            			if(MODE>6)MODE=0;                   //  0 - 6.
          			}
          			else
					{
						if((MODE<8)||(MODE>16))MODE=8;    	//  -  8 - 16.
					}
          			SW_M_CNT=0;                       	//  .
        		}
      		}
				if (SW_DWN || SW_UP)				// :
				{
					if (MODE==8 || MODE==10)				//   
					{
						PARAMETR=(unsigned int)C;			// .
					}
					if (MODE==12)						//  ,[]
					{
						if(SW_DWN)PARAMETR--;				//,
						if(SW_UP)PARAMETR++;				//.
						if((PARAMETR<1)||(PARAMETR>999))    // 
						{
							PARAMETR=500;                      //.
						}
					}
					if (MODE==14)						//  -  
					{
						if(SW_DWN)PARAMETR--;				//,
						if(SW_UP)PARAMETR++;				//.
						if((PARAMETR<1)||(PARAMETR>200))    // 
						{
							PARAMETR=100;                   	//.
						}
					}
					if (MODE==16)						//  -  E
					{
						if(SW_DWN)PARAMETR--;				//,
						if(SW_UP)PARAMETR++;				//.
						if((PARAMETR<1)||(PARAMETR>99))    // 
						{
							PARAMETR=50;                   	//.
						}
					}
					if(SW_DWN && SW_UP)					// ,     .
					{
						PARAMETR_H=PARAMETR>>8;				//    
		  				PARAMETR_L=PARAMETR;				//  .
						eeprom_write(MODE,PARAMETR_H);	    // 
						EEIF=0;								// 					      
						eeprom_write((MODE+1),PARAMETR_L);	// .		      
						EEIF=0;						     
						PARAMETR=(eeprom_read(MODE)<<8)+(eeprom_read(MODE+1));	//   .
					}
					switch(MODE)						//   : 			
					{
						case 8:h=PARAMETR;					//Cmax.   , 
						break;
						case 10:o=PARAMETR;					//Cmin.   ,
						break;
						case 12:L=PARAMETR;					//  ,
						break;
						case 14:c=PARAMETR;					// -  .
						break;
						case 16:e=PARAMETR;					// -  E.
					}
					_k=(unsigned long)c*kc;					//   .
				}
			TRISB=0b00000001;PORTB=PORTB_T;ON=ON_T;		//
			THOUS=THOUS_T;HUND=HUND_T;TEN=TEN_T;		// .
		}		
}

/*********************************************************************************
*
*			main
*
*********************************************************************************/
						
void main(void)
{
	unsigned char ACNT;			// .
	unsigned char S=8;    		// .					
	unsigned int Fb;			// .
	signed long F_pr;			//.					
	unsigned long F_S;			// .
	signed long F_A;			// .

	CMCON=VRCON=0b00000111;						//    .
	TRISA=0b11110000;							//   : (7-4)  : (3-0).
	TRISB=0;									//    (0).
	PORTA=0b00001111;							//  .
	PORTB=0xff;									// .
	OPTION=0b10110111;							// 0 .  RA4,  , . 1:256, . .
	INTCON=0b11000000;							//. .  .   .
	T1CON=0b00110001;							// 1 ., Tosc/4, . 1:8.
	PIE1=0b00000001;							//.    1.
	PIR1=0;										//  .
	h=(eeprom_read(8)<<8)+(eeprom_read(9));		//   EEPROM.
	if((h<1)||(h>60000))                        // .
	{
		h=20000;                                //   
	}
	o=(eeprom_read(10)<<8)+(eeprom_read(11));	//    
	if((o<1000)||(o>10000))                     // ,    
	{
		o=1000;                                 //    FFFF (65535).
	}
	L=(eeprom_read(12)<<8)+(eeprom_read(13));	//  
	if((L<1)||(L>999))                          //  
	{
		L=500;                                  // ,  , 
	}
	c=(eeprom_read(14)<<8)+(eeprom_read(15));	//    
	if((c<1)||(c>200))    						//,
	{
		c=100;                   				//  . 
	}
	e=(eeprom_read(16)<<8)+(eeprom_read(17));	//
	if((e<1)||(e>99))    						//
	{
		e=50;                   				//
	}
	_k=(unsigned long)c*kc;						//   .
	St=1;										//   .

/*********************************************************************************
*
*			 
*
*********************************************************************************/

	while(1)					//  .
   {
		if (MeasEnd)				//    ,
		{
			MeasEnd=0;						//    .
			if(St) Fb=_F;					//     .
			else   Fb=_F/10;				//   - 10%   .
	 	   	F_A=F;               			//    
			F_pr=_F; 						//   .
	      	if((F_pr-F_A)>Fb) F_pr=F_A+Fb; 	// 
	     	if((F_A-F_pr)>Fb) F_pr=F_A-Fb; 	//.
	  		if(ACNT<S)						//
	  		{									
				F_S=F_S+F_pr; 					// ACNT
				ACNT++;							//.
			}
	  		else						//   
	  		{
				F=F_S/ACNT;					//   [  10].
				St=0;	
				ACNT=0;						// 
				F_S=0;					   	//.
				C=_k/((F*F)/1000);			//    ,    .
				if(C>60000) C=60000;		// 
				if(C<=o) C=o+1;				//.	
				H=(L*(C-o))/(h-o);			//       .
				E=(e*(C-o))/(h-o);			// E    E .
	  		}
			SetMode();					//   .
		}
		RCNT=2000;					//   
		while(RCNT--!=0);			//  4 .		
		Led7x4Dysplay();			//.
	}
}

/*********************************************************************************
*
*			    main
*
**********************************************************************************	
*
*			 ( )
*
*********************************************************************************/

void interrupt Capmeslev(void)
{
	if(TMR1IF)							//   1.
	{
		F_OUT=1;							//   "1",     .
		F_MODE=0;							// .
		F_HI=TMR0;							//    .
		COUNT=0;							//  .
		while(TMR0==F_HI)					//    ,
		{	
			F_OUT=0;						//    , 
			COUNT++;						// .   
			F_OUT=1;						// .
 		}
		COUNT=~COUNT;						//     
		COUNT++;							//  +1.
		_F=((F_HI<<8)+COUNT);				//    .
		F_OUT=0;							//  "0",     .	
		TMR0=0;								//  0  .
		TMR1IF=0;							//  .
		TMR1H=0x0B;							//  
		TMR1L=0xDD;							//0,1  - .
		F_MODE=1;							//   ( ).
		MeasEnd=1;							// .		
	}
}

/*********************************************************************************
*
*			 "   " !?
*
*********************************************************************************/









